package neustore.base;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Arrays;

/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class ByteArrayData implements Data<byte[]> {

    private byte[] value;
    
    public ByteArrayData(byte[] value) {
            this.value = value;
    }
    
    public Object clone() {
            return new ByteArrayData(value);
    }

    public int size() {
            return value.length + 4;
    }

    public int maxSize() {
            return size();
    }

    public void read(DataInputStream in) throws IOException {
            int length = in.readInt();
            if (length < 0) {
                throw new DBRuntimeException();
            }

            
            value = new byte[length];
            in.read(value);
    }

    public void write(DataOutputStream out) throws IOException {
            out.writeInt(value.length);
            out.write(value);
    }

    public byte[] value() {
        return value;
    }
    
    @Override
    public String toString() {
            return getClass().getSimpleName() + "[value=" + Arrays.toString(value()) + "]";
    }
}
