package neustore.base;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
 * 
 * @author Svein Erik
 */
public class DoubleKey implements Key<Double> {
    public double key;

    public DoubleKey(double _key) {
        key = _key;
    }

    public Object clone() {
        DoubleKey newKey = new DoubleKey(key);
        return newKey;
    }

    public int size() {
        return 8;
    }

    public int maxSize() {
        return 8;
    }

    public void read(DataInputStream in) throws IOException {
        key = in.readDouble();
    }

    public void write(DataOutputStream out) throws IOException {
        out.writeDouble(key);
    }

    public int compareTo(Key<?> key2) {
        return value().compareTo((Double)key2.value());
    }

    public boolean equals(Key<Double> key2) {
        return compareTo(key2) == 0;
    }

    public Double value() {
        return key;
    }
    
    @Override
    public String toString() {
        return getClass().getSimpleName() + "[value=" + value() + "]";
    }
}
