package neustore.base;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.util.Arrays;

/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class FloatArrayData implements Data<float[]>, Serializable {

    private float[] value;
    
    public FloatArrayData(float[] value) {
            this.value = value;
    }
    
    public Object clone() {
            return new FloatArrayData(value);
    }

    public int size() {
            return value.length * 4 + 4;
    }

    public int maxSize() {
            return size();
    }

    public void read(DataInputStream in) throws IOException {
            int length = in.readInt();
            if (length < 0) {
                throw new DBRuntimeException();
            }

            
            value = new float[length];
            for (int i = 0; i < value.length; i++) {
                value[i] = in.readFloat();
            }
    }

    public void write(DataOutputStream out) throws IOException {
            out.writeInt(value.length);
            for (int i = 0; i < value.length; i++) {
                out.writeFloat(value[i]);
            }
    }

    public float[] value() {
        return value;
    }
    
    @Override
    public String toString() {
            return getClass().getSimpleName() + "[value=" + Arrays.toString(value()) + "]";
    }
}
