package neustore.base;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;

/**
 * An integer key.
 * 
 * @author Donghui Zhang &lt;donghui@ccs.neu.edu&gt;
 */
public class IntKey implements Key<Integer> , Serializable{
    private int key;

    public IntKey(int _key) {
        key = _key;
    }

    public Object clone() {
        IntKey newKey = new IntKey(key);
        return newKey;
    }

    public int size() {
        return 4;
    }

    public int maxSize() {
        return 4;
    }

    public void read(DataInputStream in) throws IOException {
        key = in.readInt();
    }

    public void write(DataOutputStream out) throws IOException {
        out.writeInt(key);
    }

    public int compareTo(Key<?> key2) {
    	//System.out.println("key2 " + key2.value());
    	//System.out.println("key " + value());
        return value().compareTo((Integer)key2.value());
    }

    public Integer value() {
        return key;
    }
    
    @Override
    public int hashCode() {
        return value().hashCode();
    }
    
    @Override
    public boolean equals(Object obj) {
        return value().equals(((IntKey)obj).value());
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "[value=" + value() + "]";
    }
}
