package neustore.base;


public class LinkedList<ItemType>{
	private LinkedListNode<ItemType> first = null;
	private LinkedListNode<ItemType> last = null;
	private int size;
	
	public LinkedList(){
		size=0;
	}
	
	public int size(){
		return size;
	}
	
	public LinkedListNode<ItemType> getFirst(){
		return first;
	}
	
	public LinkedListNode<ItemType> getLast(){
		return last;
	}
	
	public LinkedListNode<ItemType> insertFirst(ItemType content){	
		LinkedListNode<ItemType> newNode = new LinkedListNode<ItemType>(content, null, first);
		if (first != null) first.prevNode = newNode;
		first = newNode;
		if (size++ == 0) last = first;
		return first;
	}

	public LinkedListNode<ItemType> insertLast(ItemType content){
		LinkedListNode<ItemType> newNode = new LinkedListNode<ItemType>(content, last, null);
		if (last != null) last.nextNode = newNode;
		last = newNode;
		if (size++ == 0) first = last; 
		return last;
	}
	
	public void remove(LinkedListNode<ItemType> node){
		LinkedListNode<ItemType> nextNode = node.nextNode;
		LinkedListNode<ItemType> prevNode = node.prevNode;
		if (nextNode != null) nextNode.prevNode = prevNode;
		if (prevNode != null) prevNode.nextNode = nextNode;
		if (node == first) first = node.nextNode;
		if (node == last) last = node.prevNode;
		size--;
	}
	
}