/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ntnustore.btree;

import java.io.IOException;

import neustore.base.DBRuntimeException;
import neustore.base.Key;
import neustore.base.Data;
import ntnustore.dlaesa.Cursor;
/**
 *
 * @author Svein Erik
 */
public class BTreeCursor<K extends Key<?>, D extends Data<?>> implements Cursor<K, D> {
    private BTree<K, D> btree;
    private BTreePage<K, D> myPage;
    private BTreePage<K, D> startPage;
    private K startKey;
    private K stopKey;
    private int recPos;
    private int scanned;
    public BTreeCursor (BTree<K, D> bt, BTreePage<K, D> page, K _startKey, K _stopKey) {
        btree = bt;
        myPage = page;
        startPage = myPage;
        startKey = _startKey;
        recPos = myPage.records.findForScan(startKey);
        //System.out.println("init cursor, recPos="+recPos+" key="+startKey.toString());
        stopKey = _stopKey;
        scanned = 0;
    }
    
    public void startRescan () {
        myPage = startPage;
        recPos = myPage.records.findForScan(startKey);
    }

    public boolean next () {
        if (myPage==null) {
            //System.out.println("end of input for cursor, scanned="+scanned);
            return false;
        }
        recPos++;
        if (recPos<myPage.numRecs()) {
            scanned++;
            K myKey = myPage.records.getKey(recPos);
            //System.out.println("STOPKEY: " + stopKey + "myKEY: " + myKey);
            if (myKey.compareTo(stopKey)>=0) {
                //System.out.println("end of input for cursor, scanned="+scanned+" myKey="+myKey.toString());
                return false;
            } else {
                return true;
            }
        }
        try {
            myPage = btree.getNext(myPage);
        } catch (IOException e) {
            throw new DBRuntimeException(e);
        }
        recPos = -1;
        return next();
    }

    public K getKey() {
        return myPage.records.getKey(recPos);
    }
    public D getData() {
        return myPage.records.getData(recPos);
    }
}
