package ntnustore.btree;

import neustore.base.IntKey;
import neustore.base.StringData;
//import BTreePage;

public class TestBTreePage {
	final int maxStringLength = 10;

    BTreePage TestCreate() {
	IntKey sampleKey = new IntKey(0);
	StringData sampleData = new StringData(maxStringLength, ""); 
	BTreePage bp = new BTreePage(BTreePage.BTREE_LEAF_TYPE, 0, 0, 8192, sampleKey, sampleData);
	return bp;
    }
	
    void TestInsert( BTreePage bp ) {
	bp.insert( new IntKey(10), new StringData(maxStringLength, "John"));
	bp.insert( new IntKey(30), new StringData(maxStringLength, "Adams"));
	bp.insert( new IntKey(20), new StringData(maxStringLength, "Bill"));
	bp.insert( new IntKey(40), new StringData(maxStringLength, "George"));
	bp.insert( new IntKey(60), new StringData(maxStringLength, "Tom"));
	bp.insert( new IntKey(70), new StringData(maxStringLength, "Jack"));
    }

    void TestSearch( BTreePage bp ) {
	StringData sd = (StringData)bp.search( new IntKey(60) );
	if ( sd != null ) {
	    System.out.println("Good, key 60 corresponds to " + sd.value() );
	}
	else {
	    System.out.println("Strange, key=60 was not found.");
	}
	sd = (StringData)bp.search( new IntKey(35) );
	if ( sd != null ) {
	    System.out.println("Strange, key=35 was not inserted but found.");
	}
	else {
	    System.out.println("Good, key=35 was not inserted and not found.");
	}
    }
	
    public static void main(String[]args) {
	System.out.println( "***** Creating databases *****" );		
	TestBTreePage test = new TestBTreePage();		
	BTreePage bp = test.TestCreate();
	
	System.out.println( "***** Inserting keys *****");
	test.TestInsert(bp);
		
	System.out.println( "***** Searching keys *****" );
	test.TestSearch(bp);
		
	System.out.println( "***** Deleting key=60 from bp *****" );
	bp.delete( new IntKey(60) );

	System.out.println( "***** Searching keys 60 *****" );
	StringData sd = (StringData)bp.search( new IntKey(60) );
	if ( sd != null ) {
	    System.out.println("Strange, key=60 was deleted but still found." );
	}
	else {
	    System.out.println("Good, key=60 was deleted and thus not found.");
	}
    }
}

