package ntnustore.distance;

import neustore.base.FloatArrayData;

/**
 * TODO: Description of type.
 * 
 * @version $Id$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class ChebyshevDistance implements Distance<FloatArrayData> {
    private float[] pos;
    private int calculations;

    public ChebyshevDistance() {
    }

    public void initialize(FloatArrayData str1) {
        pos = str1.value();
    }

    public float distance(FloatArrayData str2) {
        calculations++;
        
        float[] s = str2.value();
        float max = 0.0F;
        for (int i = 0; i < pos.length; i++) {
        	max = Math.max(max, Math.abs(pos[i] - s[i]));
        }

        return max;
	}

	public int getCalculations() {
        return calculations;
    }
}
