package ntnustore.distance;

import neustore.base.FloatArrayData;

/**
 * TODO: Description of type.
 * 
 * @version $Id: L2Distance.java 50 2008-11-26 17:13:39Z erikbagg $
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class L2Distance implements Distance<FloatArrayData> {
    private float[] pos;
    private int calculations;
    
    public L2Distance() {
    }

    public L2Distance(FloatArrayData str1) {
        initialize(str1);
    }

    public void initialize(FloatArrayData str1) {
        pos = str1.value();
    }

    public float distance(FloatArrayData str2) {
        calculations++;
        
        float[] s = str2.value();
        float d2 = 0;
        for (int i = 0; i < pos.length; i++) {
            float d = pos[i] - s[i];
            d2 += d*d;
        }

        return (float)Math.sqrt(d2);
    }

    public int getCalculations() {
        return calculations;
    }
}
