package ntnustore.distance;

import neustore.base.FloatArrayData;

/**
 * TODO: Description of type.
 * 
 * @version $Id$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class LXDistance implements Distance<FloatArrayData> {
    private float[] pos;
    private int calculations;
	private float power;
    
    public LXDistance(float power) {
    	this.power = power;
    }

    public void initialize(FloatArrayData str1) {
        pos = str1.value();
    }

    public float distance(FloatArrayData str2) {
        calculations++;
        
        float[] s = str2.value();
        double d2 = 0;
        for (int i = 0; i < pos.length; i++) {
        	double d = pos[i] - s[i];
            d2 += Math.pow(Math.abs(d), power);
        }
        
        return (float) Math.pow(d2, 1/power);
    }

	public int getCalculations() {
        return calculations;
    }
}
