/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ntnustore.distance;

import neustore.base.FloatArrayData;
/**
 *
 * @author Svein Erik
 */
public class QFDistance implements Distance<FloatArrayData> {
    private float[] pos;
    private float[][] matrix;
    private int calculations;

    public QFDistance() {
    }

    public QFDistance(FloatArrayData str1, float [][] m1) {
        initialize(str1,m1);
    }

    public void initialize(FloatArrayData str1) {
        pos = str1.value();
        matrix = null;
    }

    public void initialize(FloatArrayData str1, float[][] m1) {
        pos = str1.value();
        matrix = m1;
    }

    public float distance(FloatArrayData str2) {
        calculations++;

        float[] s = str2.value();
        float d2 = 0;
        for (int i = 0; i < pos.length; i++) {
            for (int j=0; j < s.length; j++) {
                float d = (pos[i] - s[i]) * (pos[j] - s[j]) * matrix[j][i];
                d2 += d;
            }
        }

        return (float)Math.sqrt(d2);
    }

    public int getCalculations() {
        return calculations;
    }
}
