package ntnustore.dlaesa;

import java.io.IOException;

import neustore.base.DBRuntimeException;
import neustore.base.Data;
import neustore.base.IntData;
import neustore.base.IntKey;
import neustore.base.Key;
import ntnustore.btree.BTree;
import ntnustore.distance.Distance;

/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class DistanceCursor<K extends Key<?>, D extends Data<?>> implements Cursor<K, Float> {
    private Cursor<K, Float> cursor;
    private BTree<IntKey, D> dataFile;
    private Distance<D> distance;
    private float rangeLimit;
    private float currentDistance;

    public DistanceCursor(Cursor<K, Float> cursor, BTree<IntKey, D> dataFile, Distance<D> distance, float rangeLimit) {
        super();
        this.cursor = cursor;
        this.dataFile = dataFile;
        this.distance = distance;
        this.rangeLimit = rangeLimit;
    }

    public boolean next() {
        while (cursor.next()) {
            try {
                D data = dataFile.search(new IntKey(((IntData)getKey()).value()));
                currentDistance = distance.distance(data);
                if (currentDistance <= rangeLimit) {
                    return true;
                }
            } catch (IOException e) {
                throw new DBRuntimeException(e);
            }
        }
        return false;
    }

    public K getKey() {
        return cursor.getKey();
    }

    public Float getData() {
        return currentDistance;
    }
}
