package ntnustore.dlaesa;

import java.util.HashMap;


/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class MaxFloatHashJoin<K> implements Cursor<K, Float> {
	private int count;
    private Cursor<K, Float> cursor1;
    private Cursor<K, Float> cursor2;
    
    private HashMap<K, Float> hashData;

    public MaxFloatHashJoin(Cursor<K, Float> cursor1, Cursor<K, Float> cursor2) {
        this.cursor1 = cursor1;
        this.cursor2 = cursor2;
        this.count = 0;
    }
    
    public boolean next() {
        if (hashData == null) {
            hashData = new HashMap<K, Float>();
            
            while (cursor1.next()) {
                hashData.put(cursor1.getKey(), cursor1.getData());
            }
        }
        
        while (cursor2.next()) {
            if (hashData.containsKey(cursor2.getKey())) {
                count++;
                return true;
            }
        }
        return false;
    }

    public K getKey() {
        return cursor2.getKey();
    }
    
    public Float getData() {
        return Math.max(hashData.get(getKey()), cursor2.getData());
    }
}
