package ntnustore.dlaesa;

import neustore.base.Data;
import neustore.base.Key;

/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class RangeCursor<K extends Key<?>, D extends Data<?>> implements Cursor<K, D> {
    private Cursor<K, D> cursor;
    private K rangeMin;
    private K rangeMax;

    public RangeCursor(Cursor<K, D> cursor, K rangeMin, K rangeMax) {
        this.cursor = cursor;
        this.rangeMin = rangeMin;
        this.rangeMax = rangeMax;
    }

    public boolean next() {
        while (cursor.next()) {
            K key = cursor.getKey();
            if ((rangeMin.compareTo(key) <= 0) && (rangeMax.compareTo(key) >= 0)) {
                return true;
            }
        }
        return false;
    }

    public K getKey() {
        return cursor.getKey();
    }

    public D getData() {
        return cursor.getData();
    }
}
