package ntnustore.dlaesa;


/**
 * SwapCursor swaps the key and data of the input cursor.
 * 
 * @version $Id:$
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class SwapCursor<K, D> implements Cursor<K, D> {
    private Cursor<D, K> cursor;

    public SwapCursor(Cursor<D, K> cursor) {
        super();
        this.cursor = cursor;
    }

    public boolean next() {
        return cursor.next();
    }
    
    public K getKey() {
        return cursor.getData();
    }
    
    public D getData() {
        return cursor.getKey();
    }
}
