/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ntnustore.relalg;

import java.io.IOException;
import ntnustore.btree.BTreeCursor;
import neustore.base.Data;
import neustore.base.IntData;
import ntnustore.relalg.IntHash;

/**
 *
 * @author Svein Erik
 */
public class HashJoin {
    final int maxInputs = 20;
    private BTreeCursor[] inputs;
    private int nInputs;
    private int nPartitions;
    private IntHash[] hashes;
    public HashJoin (int nParts) {
        nPartitions = nParts;
        inputs = new BTreeCursor [maxInputs];
        nInputs = 0;
        hashes = new IntHash [maxInputs];
    }
    public void add (BTreeCursor c, int nRecords) {
        if (nInputs < maxInputs) {
            inputs[nInputs] = c;
            hashes[nInputs++] = new IntHash (nPartitions, nRecords);
        }
    }

    public void partition () {
        Data r;
        int progressCounter = 0;
        int progressCounter2 = 0;
        for (int i=0;i<nInputs;i++) {
            while (inputs[i].next()) {
                    r = inputs[i].getData();
                    hashes[i].add(((IntData)r).value());
                    progressCounter++;
                    if (progressCounter==1000000) {
                        progressCounter2++;
                        //System.out.println("Processed yet another "+progressCounter+" numb="+progressCounter2);
                        progressCounter=0;
                    }
            }
        }
    }
    
    public void probe () {
        for (int i=0;i<nPartitions;i++) {
            for (int j=1;j<nInputs;j++) {
                hashes[j].getBlock(i).intersect(hashes[0].getBlock(i));
            }
        }
    }
    public int resultSize () {
        return hashes[0].size();
    }
    public void debugResult () {
        hashes[0].debug();            
    }
}
