/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ntnustore.relalg;

/**
 *
 * @author Svein Erik
 */
public class IntHash {
    private int blockSize;
    private int nBlocks;
    private IntHashBlock[] blocks;
    public IntHash (int nPartitions, int nValues) {
        nBlocks = nPartitions;
        blockSize = (int)(1.2*(float)(nValues/nPartitions));
        if (blockSize < 100) {
            blockSize = 100;
        }
        //System.out.println("Hash block size="+blockSize);
        blocks = new IntHashBlock[nBlocks];
        for (int i=0;i<nBlocks;i++) {
            blocks[i]=new IntHashBlock(blockSize);
        }
    }
    public IntHashBlock getBlock (int i) {
        if (i>=0 && i<nBlocks) {
            return blocks[i];
        }
        return null;
    }
    public void clear () {
        for (int i=0;i<nBlocks;i++) {
            blocks[i].clear();
        }
    }
    public void add (int i) {
        blocks[i%nBlocks].add(i);
    }
    public void markIfPresent (int i) {
        blocks[i%nBlocks].markIfPresent(i);
    }
    public void keepMarked () {
        for (int i=0;i<nBlocks;i++) {
            blocks[i].keepMarked();
        }
    }
    public int size () {
       int sz=0;
       for (int i=0;i<nBlocks;i++) {
           sz += blocks[i].nRecs();
       }
       return sz;
    }
    public void debug () {
        System.out.println("IntHash.debug nBlocks="+nBlocks);
        for (int i=0;i<nBlocks;i++) {
            blocks[i].debug();
        }
    }
}
