/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ntnustore.relalg;

/**
 *
 * @author Svein Erik
 */
public class IntHashBlock {
    private int maxValues;
    private int nValues;
    private int[] values;
    private boolean[] marked;
    private IntHashBlock nxtBlock; // separate overflow block, may be chained
    public IntHashBlock (int sz) {
        maxValues = sz;
        nValues = 0;
        values = new int[maxValues];
        marked = new boolean[maxValues];
        nxtBlock = null; 
    }
    public void debug () {
        System.out.println("nValues="+nValues);
        if (nxtBlock!=null) {
            System.out.print("overflow block ");
            nxtBlock.debug();
        }
    }
    private int find (int i) {
        for (int j=0;j<nValues;j++) {
            if (values[j]==i) return j;
        }
        return -1;
    }
    public void add (int i) {
        int pos = find(i);
        if (pos==-1) {
            if (nValues<maxValues) {
                values[nValues++] = i;
            } else {
                if (nxtBlock!=null) {
                    nxtBlock.add(i);
                } else {
                    nxtBlock = new IntHashBlock(maxValues);
                    System.out.println("adding overflow block");
                    nxtBlock.add(i);
                }
            }
        }
    }
    public void markIfPresent (int i) {
        int pos = find(i);
        if (pos!=-1) {
            marked[pos] = true;
        } else if (nxtBlock!=null) {
            nxtBlock.markIfPresent(i);
        }
    }
    public void intersect (IntHashBlock left) {
        //System.out.println("intersect nValues="+left.nValues+" nValues="+nValues);
        for (int j=0;j<nValues;j++) {
            left.markIfPresent(values[j]);
        }
        if (nxtBlock!=null) {
            nxtBlock.intersect (left);
        }
        left.keepMarked();
    }
    
    public void clear() {
        nValues = 0;
        nxtBlock = null;
    }
    public void keepMarked () {
        int newI = 0;
        for (int i=0;i<nValues;i++) {
            if (marked[i]) {
                marked[i] = false;
                values[newI++] = values[i];
                //System.out.println(values[i]);
            }
        }
        nValues = newI;
        if (nxtBlock!=null) nxtBlock.keepMarked();
    }
    public int nRecs () {
        return nValues;
    }
}
