package ntnustore.rtree;

import java.util.ArrayList;
import java.util.Collection;

import neustore.base.Data;

/**
 * TODO: Description of type.
 * 
 * @version $Id: RTreeRecordList.java 62 2009-06-19 08:32:04Z sveinbra $
 * @author Erik Bagge Ottesen <erikbagg@idi.ntnu.no>
 */
public class RTreeRecordList<D extends Data<?>> extends ArrayList<RTreeRecord<D>> {
    private static final long serialVersionUID = 1L;
    
    public RTreeRecordList() {
        super();
    }

    public RTreeRecordList(Collection<RTreeRecord<D>> records) {
        super(records);
    }

    public RTreeRegion getMinimumBoundingRectangle() {
        return getMinimumBoundingRectangle(0, size());
    }

    public RTreeRegion getMinimumBoundingRectangle(int fromIdx, int toIdx) {
        RTreeRegion regions[] = new RTreeRegion[toIdx - fromIdx];
        for (int i = 0; i < regions.length; i++) {
            regions[i] = get(i + fromIdx).mbr;
        }
        return RTreeRegion.union(regions);
    }
}
