package test;


import java.util.Collection;
import java.io.BufferedWriter;
import java.io.EOFException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.io.BufferedReader;
import neustore.base.FloatArrayData;
import neustore.base.IntData;
import neustore.base.IntKey;
import neustore.base.FloatData;
import neustore.base.LRUBuffer;
import ntnustore.btree.BTree;
import ntnustore.distance.Distance;
import ntnustore.distance.L2Distance;
import ntnustore.distance.QFDistance;
import ntnustore.dlaesa.Cursor;
import ntnustore.dlaesa.DistanceCursor;
import ntnustore.dlaesa.KnnCursor;
import ntnustore.dlaesa.LaesaBTree;
import ntnustore.dlaesa.LaesaHeapFile;
import ntnustore.dlaesa.LaesaIndex;
import ntnustore.dlaesa.LaesaIndexList;
import ntnustore.dlaesa.LaesaRTree;
import ntnustore.dlaesa.Pair;
import ntnustore.dlaesa.pivot;

/**
 * TODO: Description of type.
 * 
 * @version $Id:$
 * @author Stian Erlandsen <stianerlandsen@gmail.com>
 */
public class stianTest {
    private static final String DATA_FILE = "data/colors";
    //private static final String DATA_FILE = "data/nasa";

    //private static final int[] PIVOT_COUNTS = new int[] { 1, 2, 4, 8, 16, 32, 64, 96, 128, 160, 192, 256, 384, 512, 768, 1024 };
    //private static final int[] PIVOT_COUNTS = new int[] { 1, 2, 4, 8, 16, 32, 64, 96, 128, 160, 192, 224, 256, 320, 384, 448, 512 };
    //private static final int[] PIVOT_COUNTS = new int[] { 1, 4, 16, 32 };
    private static final int[] PIVOT_COUNTS = new int[] {10};
    //private static final int[] PIVOT_COUNTS = new int[] { 1, 2, 4, 8, 16, 32, 64, 128 };
    //private static final int[] PIVOT_COUNTS = new int[] { 448, 512 };

    //INDEX_TYPE: -1=HeapFile, 0=BTree, 1+=RTree (number indicates maximum dimensionality of R-tree)  
    private int INDEX_TYPE = 0;
    int randomInt = 25;
    private static int randomInt2 = 34599;
    private static final int NUMBER_OF_PIVOTS = 40;

    private static final int PAGE_SIZE = 8192;
    
    private static final int BUFFER_SIZE = 10000;
    //private static final float[] QUERY_RANGE = new float[]{0.6F, 0.8F, 1.0F, 1.2F, 1.4F};
    //private static final float[] QUERY_RANGE = new float[]{0.05F, 0.1F, 0.2F, 0.4F, 0.8F};
    private static final float[] QUERY_RANGE = new float[]{0.2F};

    //QUERY_COUNT: -1 = return candidate set only, 0 = perform exact distance check, X>1 = return X nearest neighbors
    private static final int QUERY_COUNT = 0;

    private static final boolean QUERY_FLUSH = true;
    
    private static final int QUERY_THREADS = 1;

    private List<FloatArrayData> queryStrings;
    
    private List<FloatArrayData> queryPivots; 

    private LRUBuffer buffer;
    private BTree<IntKey, FloatArrayData> dataFile;
    private BTree<IntKey, FloatArrayData> bp;
    private BTree<IntKey,FloatArrayData> dataFile2;
    private Map pivots;
    private Map allObjectsKeys;
    private List pivotKeys;
    private static final int k = 1;
	private static pivot[] result = new pivot[k];
	int distanceCalcs = 0;
	long timerBuildLowerBounds;
	long timerBuildLowerBounds2;
	long timerBuildLowerBoundsTotal = 0;
	long timersortLowerBounds;
	long timersortLowerBounds2;
    
	public LaesaIndexList<FloatArrayData> laesaPivotSelection(int bpCount,LRUBuffer buffer) throws IOException, InterruptedException{
		
		System.out.println("*************************************************");
		System.out.println("*                                               *");
		System.out.println("*            Pivot Selection                    *");
		System.out.println("*                                               *");
		System.out.println("*************************************************");
		System.out.println("");
		System.out.println("You have chosen to use " + bpCount + " Pivots. Hit any key to start this algorithm...");
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		//stdin.readLine();
		
		buffer.flush(null);
        buffer.clearIOs();
		pivots = new HashMap();
		pivotKeys = new ArrayList();
		Map distanceAccumulator = new HashMap();
		float distance = 0.0F;
		int i = 1;
		pivot b_marked = null;
		pivot b = null;
		LaesaIndexList<FloatArrayData> indexes = new LaesaIndexList<FloatArrayData>();
		
		Cursor<IntKey, FloatArrayData> c2 = dataFile2.query(new IntKey(0), new IntKey(Integer.MAX_VALUE));
		c2.next();
		b_marked = new pivot((IntKey)c2.getKey(),(FloatArrayData)c2.getData());
		c2 = null;
		int counter = 0;
		
		while(pivots.size() <= bpCount){
			counter++;
			LaesaIndex<FloatArrayData> index = null;
			//System.out.println("ROUND: " + i);
			Cursor<IntKey, FloatArrayData> c = dataFile2.query(new IntKey(0), new IntKey(Integer.MAX_VALUE));
			float maxDistance = 0;
			b = b_marked;
			Distance<FloatArrayData> initializeDistance = new L2Distance((FloatArrayData)b.getData());
			index = new LaesaBTree<FloatArrayData>(buffer, "data/pivot" + b.getKey(), initializeDistance);
			while (c.next()){
				while(pivots.containsKey(c.getKey())){c.next();}
				distance = index.insert2((IntKey)c.getKey(), (FloatArrayData)c.getData());
				if(distanceAccumulator.containsKey(c.getKey())){
					float temp = (Float)(distanceAccumulator.get(c.getKey()));
					distanceAccumulator.put(c.getKey(), temp+distance);
				}
				else{distanceAccumulator.put(c.getKey(), distance);}
				if((Float)(distanceAccumulator.get(c.getKey()))> maxDistance){
					b_marked.setKey((IntKey)c.getKey());
					b_marked.setData((FloatArrayData)c.getData());
					maxDistance = (Float)distanceAccumulator.get(c.getKey());
				}
			}

			pivots.put(b_marked.getKey(), b_marked.getData());
			pivotKeys.add(b_marked.getKey().value());
			indexes.add(index);
			index.close();
			buffer.flush(null);
			i++;
		}
		
		if(!pivotKeys.contains(1)){new File("data/pivotIntKey[value=1]").delete();}
		pivots.remove(b_marked.getKey());
		pivotKeys.remove(pivotKeys.size()-1);
		System.out.println("pivots selected: " + pivots.keySet());
		ObjectOutputStream output;
		 
		try // open file
		{
			output = new ObjectOutputStream(new FileOutputStream( "data/pivot.keys" ) );
			output.writeObject(pivotKeys);
			output.close();
			output = new ObjectOutputStream(new FileOutputStream( "data/pivots.hashmap" ) );
			output.writeObject(pivots);
			output.close();
		} // end try
		catch ( IOException ioException )
		{
			System.err.println( "Error opening file." );
		} // end catch
		return indexes;

	}
	
	
	private void readData2() throws IOException {
		
		List<FloatArrayData> fileData = TestUtil.readFloatDataFromFile(DATA_FILE + ".data");
		buffer = new LRUBuffer(BUFFER_SIZE, PAGE_SIZE);
        dataFile2 = new BTree(buffer, "data/test", true, new IntKey(0), fileData.get(0));
        int key = 0;
        for (FloatArrayData data : fileData) {
            key++;
            dataFile2.insert(new IntKey(key), data);
        }
        dataFile2.close();
	}
	public void read(LRUBuffer buffer,stianTest test) throws IOException{
		BTree index = new BTree(buffer, "data/pivotIntKey[value=1]", false,new IntKey(0),new FloatData(0.0F));
		Cursor c = index.query(new IntKey(1), new IntKey(100));
		while (c.next()){
			System.out.println("KEY: " + c.getKey() +" DATA: " + c.getData());
		}
		index.close();
	}
	static Map sortByValue(Map map) {
	     List list = new LinkedList(map.entrySet());
	     Collections.sort(list, new Comparator() {
	          public int compare(Object o1, Object o2) {
	               return ((Comparable) ((Map.Entry) (o1)).getValue())
	              .compareTo(((Map.Entry) (o2)).getValue());
	          }
	     });

	    Map result = new LinkedHashMap();
	    for (Iterator it = list.iterator(); it.hasNext();) {
	        Map.Entry entry = (Map.Entry)it.next();
	        result.put(entry.getKey(), entry.getValue());
	    }
	    return result;
	}
  //O = all Objects, P = pivots, D = pivot-object-distances, PK=pivot-keys, x = test-object k = number of nearest neighbors
    
    @SuppressWarnings({ "rawtypes", "unchecked" })
	public pivot[] laesaAlgorithm(Map O, Map P, Map D, List PK, FloatArrayData x, float[][] matrix, int k) throws IOException{
		System.out.println("*************************************************");
		System.out.println("*                                               *");
		System.out.println("*            Laesa KNN Algorithm                *");
		System.out.println("*                                               *");
		System.out.println("*************************************************");
		System.out.println("");
		System.out.println("Hit any key to start this algorithm using "+ PK.size() +" pivots...");
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		//stdin.readLine();
		
		O.remove(new IntKey(randomInt));
    	float dxs; //dxs
		//QFDistance distanceType = new QFDistance();
		L2Distance distanceType = new L2Distance();
		Map G = new HashMap();
		Map dxsAll = new HashMap();
		float pmin = Float.POSITIVE_INFINITY;;
		float gmin = 0.0F;
		IntKey Resultkey = null;
		FloatArrayData ResultData = null;
		float bestRealDistanceSoFar = Float.POSITIVE_INFINITY;
		pivot init = new pivot(null,null);
		init.setDistance(Float.POSITIVE_INFINITY);
		result[0] = init;
		distanceType.initialize(x);
		int added = 0;
		pivot candidate = null;
		int counter2 = 0;

		//if no pivots used
		if(PK.size() == 0){
			Iterator it = O.entrySet().iterator();
			while (it.hasNext()) {
				counter2++;
				Map.Entry pair = (Map.Entry)it.next();
				float dpx = distanceType.distance((FloatArrayData)O.get(pair.getKey()));
				distanceCalcs++;
				if(k == 1){
					if(dpx < pmin){
						ResultData = (FloatArrayData)O.get(pair.getKey());
						Resultkey = (IntKey)pair.getKey();
						candidate = new pivot(Resultkey, ResultData);
						pmin = dpx;
					}
				}
				else if((added < k) || (result[k-1] != null && dpx < result[k-1].getDistance())){
					ResultData = (FloatArrayData)O.get(pair.getKey());
					Resultkey = (IntKey)pair.getKey();
					candidate = new pivot(Resultkey, ResultData);
					candidate.setDistance(dpx);
					if(added < k){
						for (int a = 0; a < k ; a++){
							if(result[a] != null && dpx < result[a].getDistance()){
								for(int b = added+1; b > a && b <= k; b--){
										if(b == k ){b = 4;}
										result[b] = result[b-1];
								}
								result[a] = candidate;
								break;
							}
						}
					}
					else{
						int counter = 0;
						int ole = k-1;
						if(dpx <= result[k-1].getDistance()){
							for(int b = ole; b > 0; b--){
								if(dpx <= result[b-1].getDistance()){
									counter++;
								}
								else{break;}
							}
							for(int c = 0; c < counter; c++){
								int indeks = (k-1)-c;
								result[indeks] = result[indeks-1];
							}
							result[ole - counter] = candidate;
						}
					}
					added++;
				}
				if(k == 1){
					candidate.setDistance(pmin);
					result[0] = candidate;
				}
			}
		}
		//If pivots used, build lower bounds:
		else{
			timerBuildLowerBounds = System.currentTimeMillis();
			for(int ii = 1; ii <= P.size(); ii++){
				IntKey key = new IntKey((Integer)PK.get(ii-1));
				FloatArrayData data = (FloatArrayData)P.get(key);
				pivot BP = new pivot(key,data);
				dxs = distanceType.distance(BP.getData());
				distanceCalcs++;
				dxsAll.put(key, dxs);
			}
			Iterator itr = dxsAll.entrySet().iterator();
			long t1 = System.currentTimeMillis();
			while(itr.hasNext()){
				Map.Entry pair = (Map.Entry)itr.next();
				IntKey BPkey = (IntKey)pair.getKey();
				Float dBPs = (Float)pair.getValue();
				int BPkeyi = BPkey.value();
				if(pmin > (Float)pair.getValue()){
					pmin = (Float)pair.getValue();
				}
				BTree distances = (BTree)D.get(BPkeyi);
				Iterator it = O.entrySet().iterator();
				int counter = 0;
				int counter1 = 0;
				long timer1_2 = 0;
				long timer3_4 = 0;
				
				Cursor testCursor = distances.query(new IntKey(1), new IntKey(Integer.MAX_VALUE));
			    	
				
				while (testCursor.next()) {					
					//System.out.println("Key " + testCursor.getKey() + " Data: " + testCursor.getData());
					if(((IntKey)((testCursor.getKey()))).value() == randomInt){
						testCursor.next();
					}
					long timer3 = System.currentTimeMillis();
					while(dxsAll.containsKey(testCursor.getKey()) || testCursor.getData() == null){
						testCursor.next();
					}
					Float p_distance_s = ((FloatData)testCursor.getData()).value();
					long timer2 = System.currentTimeMillis();
					if(!G.containsKey(testCursor.getKey())){G.put(testCursor.getKey(), 0.0F);}
					if((Float)G.get(testCursor.getKey()) < Math.abs(p_distance_s - (Float)pair.getValue())){
						G.put(testCursor.getKey(), Math.abs(p_distance_s - (Float)pair.getValue()));
						if(Math.abs(p_distance_s - (Float)pair.getValue()) > gmin){
							gmin = Math.abs(p_distance_s - (Float)pair.getValue());
						}
					}
				}				
			}
			G.remove(new IntKey(randomInt));			
			long t2 = System.currentTimeMillis();
			long timersortLowerBounds = System.currentTimeMillis();
			SortedMap sortedData = new TreeMap(new MapValueSort.ValueComparer(G));
			sortedData.putAll(G);
			long timersortLowerBounds2 = System.currentTimeMillis();
			//MapValueSort sort = new MapValueSort();
			//sort.printMap(sortedData);	
			Iterator it = sortedData.entrySet().iterator();
			timerBuildLowerBounds2 = System.currentTimeMillis();
			timerBuildLowerBoundsTotal = timerBuildLowerBoundsTotal + (timerBuildLowerBounds2 - timerBuildLowerBounds);
			long t3 = System.currentTimeMillis();
			
			
			//calculating result
			pmin = Float.POSITIVE_INFINITY;
			while (it.hasNext()) {
				counter2++;
				Map.Entry pairs = (Map.Entry)it.next();
				ResultData = (FloatArrayData)O.get(pairs.getKey());
				Resultkey = (IntKey)pairs.getKey();
				candidate = new pivot(Resultkey, ResultData);
				float dpx = 0.0F;
				
				if(k == 1){
					if((Float)sortedData.get(pairs.getKey()) > pmin){
						System.out.println("lowerbound > best distance found so far, breaking...");
						break;
						}
					if(dxsAll.containsKey(pairs.getKey())){pairs = (Map.Entry)it.next();}
					else{
						//System.out.println("counter: " + counter2 + " pairs.getKey() " + pairs.getKey() + " O.get " + O.get(pairs.getKey()));
						dpx = distanceType.distance((FloatArrayData)O.get(pairs.getKey()));
						distanceCalcs++;
						if(dpx < pmin){
							pmin = dpx;
							candidate.setDistance(pmin);
							result[0] = candidate;
						}
					}
				}
				else if((added < k)){
					dpx = distanceType.distance((FloatArrayData)O.get(pairs.getKey()));
					distanceCalcs++;
					candidate.setDistance(dpx);
					for (int a = 0; a < k ; a++){
						if(result[a] != null && dpx < result[a].getDistance()){
							for(int b = added+1; b > a && b <= k; b--){
									if(added == 2 ){System.out.println("b " + b);}
									if(b == k ){b = k-1;}
									result[b] = result[b-1];
							}
							result[a] = candidate;
							added++;
							break;
						}
					}
				}
				else{
					if((Float)sortedData.get(pairs.getKey()) > result[k-1].getDistance()){
						System.out.println("stopped after going through " + counter2 + " objects");
						break;
					}
					
					dpx = distanceType.distance((FloatArrayData)O.get(pairs.getKey()));
					distanceCalcs++;
					candidate.setDistance(dpx);
					int counter = 0;
					int ole = k-1;
					
					if(dpx <= result[k-1].getDistance()){
						for(int b = ole; b > 0; b--){
							if(dpx <= result[b-1].getDistance()){
								counter++;
							}
							else{break;}
						}
						for(int c = 0; c < counter; c++){
							int indeks = (k-1)-c;
							result[indeks] = result[indeks-1];
						}
						result[ole - counter] = candidate;
					}
				}
			}
			long t4 = System.currentTimeMillis();
			System.out.println("Time spent calculating distances: " + (t4 - t3)/1000 + " Seconds.");
			
		}
		
		System.out.println("Total number of Objects " + O.size());
		System.out.println("Total distancecalculations: " + distanceCalcs);
		return result;
	}
    


	public static void main(String[] args) throws Exception {
		//TestUtil.deleteFiles();
		//System.exit(0);
		
		
		float[] n_sample = {-0.214579F, 0.224219F, -0.123123F, 0.0759739F, 0.433112F, 0.23946F, -0.0233754F, 0.327327F, 0.0959396F, 0.115914F, 0.0110738F, -0.16896F, -0.0705952F, 0.306239F, 0.263311F, -0.0360219F, -0.0268898F, 0.164756F, 0.121092F, -0.0319838F};
		FloatArrayData nasa_sample = new FloatArrayData(n_sample);
		float[] c_sample = {0.1977F, 0.34111F, 0.0347584F, 0.01284F, 0.0F, 0.0F, 3.6169E-5F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.00141059F, 7.2338E-5F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0584852F, 0.0F, 0.0210142F, 0.0616319F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.00669126F, 0.0010489F, 0.0F, 0.0F, 0.0396412F, 0.0F, 0.0279225F, 0.0240524F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.053928F, 0.00115741F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0298756F, 0.0F, 0.00329138F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0581236F, 0.00842737F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 5.78704E-4F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0160229F, 1.80845E-4F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F};
		FloatArrayData colors_sample = new FloatArrayData(c_sample);
		BTree allObjects;
		
		
		int[] pivots = new int[20];
		
		pivots[0] = 5;
		pivots[1] = 10;
		pivots[2] = 15;
		pivots[3] = 20;
		pivots[4] = 25;
		pivots[5] = 30;
		pivots[6] = 35;
		pivots[7] = 40;
		pivots[8] = 45;
		
		pivots[9] = 50;
		pivots[10] = 55;
		pivots[11] = 60;
		pivots[12] = 65;
		pivots[13] = 70;
		
		pivots[14] = 75;
		pivots[15] = 80;
				
		pivots[16] = 85;
		pivots[17] = 90;
		pivots[18] = 95;
		pivots[19] = 100;

		//pivots[0] = 60;

		for(int iii = 0; iii < pivots.length; iii++){
		BufferedWriter out2 = new BufferedWriter(new FileWriter("data/average" +  pivots[iii] + ".txt"));
		BufferedWriter out = new BufferedWriter(new FileWriter("data/lowerbounds" +  pivots[iii] + ".txt"));
			
		LRUBuffer buffer = new LRUBuffer(10000, 8192);
		stianTest test = new stianTest();
		int average = 0;
		int testRounds = 1;
		
		//test.readData2();
		//System.exit(0);
		Random randomGenerator = new Random();
		if(DATA_FILE == "data/colors"){
			allObjects = new BTree(buffer, "data/colors_data_and_keys", false, new IntKey(0),colors_sample);
			test.dataFile2 = new BTree(buffer, "data/colors_data_and_keys", false, new IntKey(0), colors_sample);

		}
		else{
			allObjects = new BTree(buffer, "data/nasa_data_and_keys", false,new IntKey(0),nasa_sample);
			test.dataFile2 = new BTree(buffer, "data/nasa_data_and_keys", false, new IntKey(0), nasa_sample);
		}
		
		long timerOther1 = System.currentTimeMillis();
		TestUtil.deleteFiles();   		

		long timerOther2 = System.currentTimeMillis();

		long timerCreatePivots = System.currentTimeMillis();
		test.laesaPivotSelection(pivots[iii], buffer);
		long timerCreatePivots2 = System.currentTimeMillis();
		
		for(int iiii = 1; iiii <= testRounds; iiii++){
			test.distanceCalcs = 0;
			System.out.println("Testround " + iiii + " of " + testRounds);	
			long timerTotal = System.currentTimeMillis();
			
			if(DATA_FILE == "data/colors"){test.randomInt = randomGenerator.nextInt(112682);}
			else{test.randomInt = randomGenerator.nextInt(40149);}
		/*
        int sz = 0;
        for (FloatArrayData query : fileData) {
            sz = query.size();
            break;
        }
        
        float[][] matrix = new float[sz][sz];
        // create identity matrix
        for (int i = 0; i < sz; i++) {
            for (int j = 0; j < sz; j++) {
                if (i == j)
                    matrix[i][j] = 1.0F;
                else
                    matrix[i][j] = 0;
            }
        }
		*/

		
		
		

	    FloatArrayData random = (FloatArrayData)(allObjects.search(new IntKey(test.randomInt)));
	    System.out.println("Random object selected: " + random);
	    System.out.println("With key: " + test.randomInt);
		Map pivotsHashmap = new HashMap();
		Map allObjectsKeys = new HashMap();
		List pivotKeys = new ArrayList();
		Map allObjectsMap = new HashMap();
		
		ObjectInputStream inputStream = null;
		ObjectInputStream inputStream2 = null;
		ObjectInputStream inputStream3 = null;
		
		
	    try {          
	        //Construct the ObjectInputStream object
	        inputStream = new ObjectInputStream(new FileInputStream("data/pivots.hashmap"));
	        inputStream2 = new ObjectInputStream(new FileInputStream("data/pivot.keys"));
	        
	        Object obj = null;
	        Object obj2 = null;
	        
	        while ((obj2 = inputStream2.readObject()) != null) {
	        	if (obj2 instanceof ArrayList) {
	            	pivotKeys = (ArrayList)obj2;
	            }
	        	while ((obj = inputStream.readObject()) != null) {
	            	if (obj instanceof HashMap) {
	                	pivotsHashmap = (HashMap)obj;
	                }
	            }
	        }          
	    } 
	    catch (EOFException ex) { //This exception will be caught when EOF is reached
	        //System.out.println("End of file reached.");
	    } catch (ClassNotFoundException ex) {
	        ex.printStackTrace();
	    } catch (FileNotFoundException ex) {
	        ex.printStackTrace();
	    } catch (IOException ex) {
	        ex.printStackTrace();
	    } finally {
	        //Close the ObjectInputStream
	        try {
	            if (inputStream != null) {
	                inputStream.close();
	            }
	            if (inputStream2 != null) {
	                inputStream2.close();
	            }
	        } catch (IOException ex) {
	            ex.printStackTrace();
	        }
	    }
	 
	    Map listOfBTrees = new HashMap();
	    
	    long timerOther3 = System.currentTimeMillis();
	    for (int i = 0; i < pivotKeys.size(); i++){
	    	//System.out.println("data/pivotIntKey[value=" + pivotKeys.get(i));
	    	BTree index = new BTree(buffer, "data/pivotIntKey[value=" + pivotKeys.get(i) + "]", false,new IntKey(0),new FloatData(0.0F));
	    	listOfBTrees.put(pivotKeys.get(i), index);
	    }
	  
	    Cursor allObjectsCursor = allObjects.query(new IntKey(1), new IntKey(Integer.MAX_VALUE));
	    while (allObjectsCursor.next()){
	    	allObjectsMap.put(allObjectsCursor.getKey(), allObjectsCursor.getData());
	    }
	    
		//System.out.println("allobjectsmap search " +allObjectsMap.get(new IntKey(19795)));
		//System.exit(0);
	    
	    pivotsHashmap.remove(new IntKey(1));
	    long timerOther4 = System.currentTimeMillis();
	    long t1 = System.currentTimeMillis();
	    System.out.println("");	    	    
	    pivot[] p = test.laesaAlgorithm(allObjectsMap, pivotsHashmap, listOfBTrees,pivotKeys,random, null, k);
	    long t2 = System.currentTimeMillis();
	    for (int i = 0; i < result.length;i++){
	    	System.out.println("Result[" + i + "] distance = " + result[i].getDistance() + " key = " + result[i].getKey());
	    }
	    
	    //temp
	   
	    average = average + test.distanceCalcs;
	    //end temp
	    
	    //System.out.println("Time spent: " + (t2 - t1)/1000 + " Seconds.");
	    for(int i = 0; i < pivotKeys.size(); i++){
	    	BTree tempindex = (BTree) listOfBTrees.get(pivotKeys.get(i));
	    	tempindex.close();
	    }
	    long timerTotal2 = System.currentTimeMillis();
	    System.out.println("Time spent total : " + (timerTotal2 - timerTotal)/1000 + " Seconds.");
	    System.out.println("Time spent creating pivot : " + (timerCreatePivots2 - timerCreatePivots)/1000 + " Seconds.");
	    System.out.println("Time spent building lowerbounds : " + (test.timerBuildLowerBounds2 - test.timerBuildLowerBounds) + " Milliseconds.");
	    System.out.println("Time spent building lowerbounds in total: " + test.timerBuildLowerBoundsTotal + " Milliseconds.");
	    //System.exit(0);
	    System.out.println("Time spent sorting : " + (test.timersortLowerBounds2 - test.timersortLowerBounds)/1000 + " Seconds.");

		}
		int totalaverage = average / testRounds;
		System.out.println("Totalaverage: " + totalaverage + " average: " + average);
		String averagestring = Integer.toString(totalaverage);
		int temp = iii+1;
		allObjects.close();
		out2.write("pivot number: " + pivots[iii] + " average: " + averagestring);
	    out2.newLine();
	    out.write("data/lowerbounds" +  pivots[iii] + "  " + test.timerBuildLowerBoundsTotal + ".txt");
	    out.newLine();
	    out2.close();
	    out.close();
		}		
		
	}
}