package test;

import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import neustore.base.IntKey;

public class MapValueSort {

	/** inner class to do sorting of the map **/
	public static class ValueComparer implements Comparator {
		private Map  _data = null;
		public ValueComparer (Map data){
			super();
			_data = data;
		}

		public int compare(Object key1, Object key2) {
			Comparable value1 = (Comparable) _data.get(key1);
			Comparable value2 = (Comparable) _data.get(key2);
			int c = value1.compareTo(value2);
			if (0 != c)
			return c;
			Integer h1 = key1.hashCode(), h2 = key2.hashCode();
			return h1.compareTo(h2);
			}
	}

	public static void main(String[] args){

		Map unsortedData = new HashMap();
		unsortedData.put("2", 0.0F);
		unsortedData.put("1", 0.1F);
		unsortedData.put("4", 0.002F);
		unsortedData.put("3", 0.96F);

		SortedMap sortedData = new TreeMap(new MapValueSort.ValueComparer(unsortedData));

		printMap(unsortedData);

		sortedData.putAll(unsortedData);
		System.out.println();
		printMap(sortedData);
	}

	public static void printMap(Map data) {
		for (Iterator iter = data.keySet().iterator(); iter.hasNext();) {
			IntKey key = (IntKey) iter.next();
			System.out.println("Value/key:"+data.get(key)+"/"+key);
		}
	}

}
